unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, laz.VirtualTrees;

type

  { TForm1 }

  TForm1 = class(TForm)
    vstImport: TLazVirtualStringTree;
    procedure FormShow(Sender: TObject);
    procedure vstImportFreeNode(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure vstImportGetNodeDataSize(Sender: TBaseVirtualTree;
      var NodeDataSize: Integer);
    procedure vstImportGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType; var CellText: String);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  LConvEncoding;

type
  TImportColumn = TStringArray;  //Array[0..100] of string;

  TImportData = record
     Spalte : TImportColumn;
  end;

  PImportData = ^TImportData;


{ TForm1 }

procedure TForm1.vstImportFreeNode(Sender: TBaseVirtualTree; Node: PVirtualNode);
var
  data: PImportData;
  i: Integer;
begin
  data := Sender.GetNodeData(Node);
  // Strings freigeben
  for i := 0 to High(data^.Spalte) do
    data^.Spalte[i] := '';
  // Dynamisches Array freigeben
  data^.Spalte := nil;
end;

procedure TForm1.FormShow(Sender: TObject);
var sZeile : String;
    iCol, iZeile : Integer;
    vtc : TVirtualTreeColumn;
    xNode : PVirtualNode;
    Data: PImportData;
    tslCSV : TStringList;
    sa: TStringArray;
    iColCount: Integer;
begin
  tslCSV := TStringList.Create;
  try
    tslCSV.LoadFromFile('Kostenarten.csv');
    vstImport.Clear;
    vstImport.Header.Columns.Clear;
    sZeile := ConvertEncoding(tslCSV.Strings[0],GuessEncoding(tslCSV.Strings[0]), EncodingUTF8);
    sa := sZeile.Split(';');
    iColCount := Length(sa);
    for iCol := 0 to iColCount-1 do
    begin
      vtc := vstImport.Header.Columns.Add;
      vtc.Style:=vsText;
      vtc.Options := [coAllowClick,coDraggable,coEnabled,coParentBidiMode,coResizable,coShowDropMark,coVisible,coAllowFocus,coEditable];
      vtc.Width:=100;
      vtc.Text := sa[iCol];
    end;
  // füllen des Treeview aus der TStringlist
    for iZeile := 1 to tslCSV.Count-1 do
    begin
      XNode  := vstImport.AddChild(nil);
      Data := vstImport.GetNodeData(XNode);
      vstImport.ValidateNode(XNode, false);
      sZeile := ConvertEncoding(tslCSV.Strings[iZeile],GuessEncoding(tslCSV.Strings[iZeile]), EncodingUTF8);
      Data^.Spalte := sZeile.Split(';');
    end;
  finally
    tslCSV.Free;
  end;
end;

procedure TForm1.vstImportGetNodeDataSize(Sender: TBaseVirtualTree;
  var NodeDataSize: Integer);
begin
  vstImport.NodeDataSize := SizeOf(TImportData);
end;

procedure TForm1.vstImportGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
  Column: TColumnIndex; TextType: TVSTTextType; var CellText: String);
var
  data: PImportData;
begin
  data := vstImport.GetNodeData(Node);
  CellText := data^.Spalte[Column];
end;

end.

